#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

// because Geometry.draw() sets these uniforms
uniform mat3 normalMatrix;

layout (location = 0) in vec3 position;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

// cube map 
layout (location = 1) in vec3 aNormal;
layout(location = 2) in vec2 uv;

out vec3 Normal;
out vec3 Position;

// skybox
out vec3 TextureCoordinates;
uniform bool skybox;


void main()
{
    if (skybox) {
        TextureCoordinates = position;
        gl_Position = projectionMatrix * viewMatrix * vec4(position, 0.02);
    } else { 
        // reflect skybox
        Normal = mat3(transpose(inverse(modelMatrix))) * aNormal;
        Position = vec3(modelMatrix * vec4(position, 1.0));
        gl_Position = projectionMatrix * viewMatrix * vec4(Position, 1.0);
    }
}  
