#version 430 core
/*
* Copyright 2019 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout ( location = 0 ) in vec3 vertex_position;
layout ( location = 1 ) in vec4 position;
layout ( location = 2 ) in vec3 data;

uniform mat4 viewMatrix;
uniform mat4 projMatrix;

out vec3 color;

void main() {
   vec4 position_viewspace = viewMatrix * vec4( position.xyz , 1 );
   position_viewspace.xy += 0.075 * (vertex_position.xy);
   gl_Position = projMatrix * position_viewspace;
   color = data;
}